﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WMM.Tapioca.Linkbase;
using WMM.Tapioca.Instance;
using WMM.Tapioca.Taxonomy;

namespace WMM.Tapioca.Formula.Filters
{
    public abstract class BooleanFilter : Filter
    {
        private string factVariableLabel;

        public string FactVariableLabel
        {
            get { return factVariableLabel; }
            set { factVariableLabel = value; }
        }

        List<Arc> booleanFilterArcs;

        /// <returns> List of boolean-filter Arcs. </returns>
        public List<Arc> BooleanFilterArcs
        {
            get { return booleanFilterArcs; }
            set { booleanFilterArcs = value; }
        }

        private List<Filter> subFilters;

        public List<Filter> SubFilters
        {
            get { return subFilters; }
            set { subFilters = value; }
        }

        public BooleanFilter(Resource resource)
            : base(resource)
        {
            BooleanFilterArcs = new List<Arc>();
            subFilters = new List<Filter>();
        }
        
    }
}
