﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WMM.Tapioca.Instance;
using WMM.Tapioca.Taxonomy;
using WMM.Tapioca.Linkbase;

namespace WMM.Tapioca.Formula.Filters
{
    /// <summary>
    /// The concept matching filter can be used to select facts that report values for the same concept. 
    /// </summary>
    public class MatchConceptFilter : MatchFilter
    {
        /// <summary>
        /// Constructor.
        /// </summary>
        public MatchConceptFilter(Resource resource)
            : base(resource)
        {
            
        }


        public override List<FactItem> EvaluateFilter(VariableSet variableSet, List<FactItem> itemsToFilter, DTS dts)
        {
            this.dts = dts;
            namespaces = dts.DtsFormula.Namespaces;

            List<FactItem> itemListTemp = new List<FactItem>();

            foreach (FactItem itemToFilter in itemsToFilter)
            {
                List<FactItem> factItems = variableSet.variableItems[Variable];

                if (factItems.Count > 0)
                {
                    if (Complement ? !itemToFilter.Concept.Id.Equals(factItems[0].Concept.Id) :
                        itemToFilter.Concept.Id.Equals(factItems[0].Concept.Id))
                    {
                        itemListTemp.Add(itemToFilter);
                        continue;
                    }
                }

            }

            return itemListTemp;
        }
    }
}
