﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WMM.Tapioca.Instance;
using WMM.Tapioca.Taxonomy;
using WMM.Tapioca.Linkbase;

namespace WMM.Tapioca.Formula.Filters
{
    /// <summary>
    /// The entity-identifier matching filter can be used to select facts with the same entity identifier. 
    /// </summary>
    public class MatchEntityIdentifierFilter : MatchFilter
    {
        /// <summary>
        /// Constructor.
        /// </summary>
        public MatchEntityIdentifierFilter(Resource resource)
            : base(resource)
        {
            
        }


        public override List<FactItem> EvaluateFilter(VariableSet variableSet, List<FactItem> itemsToFilter, DTS dts)
        {
            this.dts = dts;
            namespaces = dts.DtsFormula.Namespaces;

            List<FactItem> itemListTemp = new List<FactItem>();

            foreach (FactItem itemToFilter in itemsToFilter)
            {
                List<FactItem> factItems = variableSet.variableItems[Variable];

                for (int i = 0; i < factItems.Count; i++)
                {
                    if (Complement ? !itemToFilter.ContextRef.Identifier.Equals(factItems[i].ContextRef.Identifier) :
                        itemToFilter.ContextRef.Identifier.Equals(factItems[i].ContextRef.Identifier))
                    {
                        itemListTemp.Add(itemToFilter);
                        continue;
                    }
                }
            }

            return itemListTemp;
        }
    }
}
