﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WMM.Tapioca.Linkbase;
using WMM.Tapioca.Instance;
using WMM.Tapioca.Taxonomy;

namespace WMM.Tapioca.Formula.Filters
{
    /// <summary>
    /// The nil filter can be used to match facts that are reported as nil. 
    /// </summary>
    public class NilFilter : Filter
    {
          /// <summary>
        /// Constructor.
        /// </summary>
        public NilFilter(Resource resource)
            : base(resource)
        {
            
        }


        public override List<FactItem> EvaluateFilter(VariableSet variableSet, List<FactItem> itemsToFilter, DTS dts)
        {
            List<FactItem> itemListTemp = new List<FactItem>();

            foreach (FactItem item in itemsToFilter)
            {
                if (Complement ? !item.IsNilSpecified : item.IsNilSpecified)
                {
                    itemListTemp.Add(item);
                }
            }

            return itemListTemp;
        }
    }
}
