﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WMM.Tapioca.Utilities
{
    /// <summary>
    /// An exception class used to report any XBRL structure or validation errors found in loaded XBRL documents.
    /// </summary>
    public class DTSDiscoveryException : Exception
    {
        /// <summary>
		/// Constructor.
		/// </summary>
		/// <param name="Message">
		/// A message to be included as part of the exception.
		/// </param>
		public DTSDiscoveryException(string Message)
			: base(Message)
		{
		}

		/// <summary>
		/// Constructor.
		/// </summary>
		/// <param name="Message">
		/// A message to be included as part of the exception.
		/// </param>
		/// <param name="Inner">
		/// An inner exception object to be included as part of the exception.
		/// </param>
        public DTSDiscoveryException(string Message, Exception Inner)
			: base(Message, Inner)
		{
		}
    }
}
