using System;

namespace WMM.Tapioca.Utilities
{
	/// <summary>
	/// An exception class used to report any XBRL structure or validation errors found in loaded XBRL documents.
	/// </summary>	
	public class XbrlException : Exception
	{
		/// <summary>
		/// Constructor.
		/// </summary>
		/// <param name="message">
		/// A message to be included as part of the exception.
		/// </param>
		public XbrlException(string message)
			: base(message)
		{
		}

		/// <summary>
		/// Constructor.
		/// </summary>
		/// <param name="message">
		/// A message to be included as part of the exception.
		/// </param>
		/// <param name="inner">
		/// An inner exception object to be included as part of the exception.
		/// </param>
		public XbrlException(string message, Exception inner)
			: base(message, inner)
		{
		}
	}
}
