﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WMM.Tapioca.Linkbase;

namespace WMM.Tapioca.XbrlDimension
{
    /// <summary>
    /// The class parent of all relationships. 
    /// </summary>
    public class DRSRelationship
    {
        private string sourceRole;

        /// <returns> The source role is the content of the @xlink:role attribute of the relationship's base set. </returns>
        public virtual string SourceRole
        {
            get
            {
                return sourceRole;
            }
            set
            {
                sourceRole = value;
            }
        }

        private Uri targetRole;

        /// <returns> The target role is the content of the @targetRole attribute on the arc itself. </returns>
        public Uri TargetRole
        {
            get { return targetRole; }
            set { targetRole = value; }
        }

        private string effectiveRole;

        public string EffectiveRole
        {
            get { return effectiveRole; }
            set { effectiveRole = value; }
        }

        private Arc arcCR;

        /// <returns> The arc this consecutive relationship. </returns>
        public Arc ArcCR
        {
            get { return arcCR; }
            set { arcCR = value; }
        }
    }
}
