﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WMM.Tapioca.Taxonomy;

namespace WMM.Tapioca.XbrlDimension
{
    /// <summary>
    /// A Domain is a Dimension Member as defined in the XDT specification. 
    /// </summary>
    public class Domain
    {
        private Concept concept; // the concept the member refers to

        /// <returns> the concept the domain refers to. </returns>
        public Concept Concept
        {
            get { return concept; }
            set { concept = value; }
        }

        private Dimension parentDimension;

        /// <returns> the parent Dimension the domain refers to. </returns>
        public Dimension ParentDimension
        {
            get { return parentDimension; }
            set { parentDimension = value; }
        }

        /// <param name="concept">
        /// The Concept object which represents the member. </param>
        /// <param name="dimension">
        /// The Dimension object which contains the member. </param>
        public Domain(Concept concept, Dimension dimension)
        {
            this.concept = concept;
            parentDimension = dimension;

        }
    }
}
