﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WMM.Tapioca.Taxonomy;

namespace WMM.Tapioca.XbrlDimension
{
    /// <summary>
    /// The relationship arc role http://xbrl.org/int/dim/arcrole/domain-member. 
    /// </summary>
    public class DomainMember : DRSRelationship
    {
        private Concept domain;

        /// <returns> the domain of this relationship (source). </returns>
        public Concept Domain
        {
            get { return domain; }
            set { domain = value; }
        }

        private Concept member;

        /// <returns> A list of member (target). </returns>
        public Concept Member
        {
            get { return member; }
            set { member = value; }
        }

        private bool usable;

        /// <returns> usable of this hypercube. </returns>
        public bool Usable
        {
            get { return usable; }
            set { usable = value; }
        }

        /// <summary>
        /// The constructor. 
        /// </summary>
        public DomainMember(Concept domain, Concept member)
        {
            Domain = domain;
            Member = member;
        }
    }
}
