﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Xml;
using System.Configuration;
using System.Net;
using WMM.Tapioca.Instance;
using WMM.Tapioca;
using WMM.Tapioca.Utilities;

namespace WMM.Test.Tapioca
{
    [TestClass]
    public class ReferenceImplementationOfSECXBRLTest
    {
        static XmlCachingResolver resolver;

        public ReferenceImplementationOfSECXBRLTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        [ClassInitialize()]
        public static void MyClassInitialize(TestContext testContext)
        {
            bool useProxy = Boolean.Parse(ConfigurationManager.AppSettings["UseProxy"]);
            resolver = new XmlCachingResolver(true, useProxy);            
        }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        [ClassCleanup()]
        public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        [TestInitialize()]
        public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        [TestCleanup()]
        public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void ReferenceImplementationOfSECXBRL()
        {
            InstanceDocument xbrlDoc = new InstanceDocument(@"..\..\..\WMM.Test.Tapioca\Reference-Implementation-of-SEC-XBRL\abc-20121231.xml", resolver);

            XbrlManager xbrlManager = new XbrlManager(xbrlDoc);            
            xbrlManager.Validate();

            // error calculation
            Assert.IsFalse(xbrlDoc.Dts.ValidatedInstance, "The instance document was not validated.");
            Assert.IsNotNull(xbrlDoc.XbrlRootElement);
            Assert.AreNotEqual<int>(0, xbrlDoc.Facts.Count, "No facts found in document.");
        }
    }
}
